﻿Imports Infragistics.UltraChart.Resources.Appearance
Imports Infragistics.UltraChart.Shared.Styles
Imports Infragistics.UltraChart.Core.Layers

Public Class Form1

    Private seriesTemp As NumericTimeSeries
    Private seriesLine As NumericTimeSeries
    Private seriesCandle As CandleSeries

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
        BindChart()
    End Sub

    Private Sub BindChart()

        UltraChart1.ChartType = ChartType.Composite
        Dim area As New ChartArea()
        UltraChart1.CompositeChart.ChartAreas.Add(area)

        'First Y_Axis
        Dim axYTemp As New AxisItem()
        axYTemp.Extent = 20
        axYTemp.RangeType = AxisRangeType.Custom
        axYTemp.RangeMin = 35
        axYTemp.RangeMax = 42
        axYTemp.DataType = AxisDataType.Numeric
        axYTemp.Labels.ItemFormatString = "<DATA_VALUE:##.##>"
        axYTemp.OrientationType = AxisNumber.Y_Axis
        axYTemp.LineThickness = 1
        axYTemp.TickmarkStyle = AxisTickStyle.DataInterval
        axYTemp.Labels.VerticalAlign = StringAlignment.Far
        axYTemp.TickmarkInterval = 1
        axYTemp.Labels.FontColor = Color.FromArgb(0, 102, 221)
        axYTemp.Key = "Y"
        area.Axes.Add(axYTemp)

        'GroupBySeries Y2_Axis : LineChart & CandleChart
        Dim axisY2 As New AxisItem()
        axisY2.Extent = 50
        axisY2.RangeType = AxisRangeType.Custom
        axisY2.RangeMin = 0
        axisY2.RangeMax = 250
        axisY2.DataType = AxisDataType.Numeric
        axisY2.Labels.ItemFormatString = "<DATA_VALUE:##.##>"
        axisY2.OrientationType = AxisNumber.Y2_Axis
        axisY2.LineThickness = 1
        axisY2.TickmarkStyle = AxisTickStyle.DataInterval
        'axisY2.SetLabelAxisType = SetLabelAxisType.GroupBySeries
        axisY2.TickmarkInterval = 10
        area.Axes.Add(axisY2)

        ' For Candle chart you will need AxisX, AxisY and AxisY2
        Dim axisYCandle = New AxisItem()
        axisYCandle.RangeType = AxisRangeType.Custom
        axisYCandle.RangeMin = 0
        axisYCandle.RangeMax = 250
        axisYCandle.DataType = AxisDataType.Numeric
        axisYCandle.Labels.ItemFormatString = "<DATA_VALUE:##.##>"
        axisYCandle.OrientationType = AxisNumber.Y_Axis
        axisYCandle.LineThickness = 1
        area.Axes.Add(axisYCandle)

        'X_Axis ContinuousData
        Dim axisX = New AxisItem()
        axisX.Extent = 50
        axisX.Labels.Orientation = TextOrientation.VerticalLeftFacing
        axisX.DataType = AxisDataType.String
        axisX.Labels.ItemFormat = AxisItemLabelFormat.ItemLabel
        axisX.OrientationType = AxisNumber.X_Axis
        axisX.Labels.Orientation = TextOrientation.Horizontal
        axisX.SetLabelAxisType = SetLabelAxisType.ContinuousData
        axisX.LineThickness = 1
        axisX.Margin.Far.Value = 2
        axisX.Margin.Near.Value = 2
        axisX.Key = "X"
        area.Axes.Add(axisX)

        ' You cannot use same X axis for Line chart and Candle chart
        ' Line chart need X axis SetLabelAxisType as ContinuousData
        ' and Candle chart need X axis SetLabelAxisType as DateData
        Dim axisXCandle = New AxisItem()
        axisXCandle.Labels.Orientation = TextOrientation.VerticalLeftFacing
        axisXCandle.DataType = AxisDataType.String
        axisXCandle.Labels.ItemFormat = AxisItemLabelFormat.ItemLabel
        axisXCandle.SetLabelAxisType = SetLabelAxisType.DateData
        axisXCandle.OrientationType = AxisNumber.X2_Axis
        axisXCandle.LineThickness = 1
        area.Axes.Add(axisXCandle)

        Dim chtlayerTemp As New ChartLayerAppearance()
        chtlayerTemp.ChartType = ChartType.LineChart
        chtlayerTemp.ChartArea = area

        Dim chtlayerY2Line As New ChartLayerAppearance()
        chtlayerY2Line.ChartType = ChartType.LineChart
        chtlayerY2Line.ChartArea = area

        Dim chtlayerY2Candle As New ChartLayerAppearance()
        chtlayerY2Candle.ChartType = ChartType.CandleChart
        chtlayerY2Candle.ChartArea = area

        Dim lineChartTemp As LineChartAppearance = chtlayerTemp.ChartTypeAppearance
        Dim lineChart As LineChartAppearance = chtlayerY2Line.ChartTypeAppearance

        ' Add values to each point of Respiration chart
        Dim chartTextAppearance As ChartTextAppearance = New ChartTextAppearance()
        chartTextAppearance.Column = -2
        chartTextAppearance.Row = -2
        chartTextAppearance.Visible = True
        chartTextAppearance.VerticalAlign = StringAlignment.Near
        chartTextAppearance.HorizontalAlign = StringAlignment.Near
        chartTextAppearance.ItemFormatString = "<DATA_VALUE:00.##>"
        chartTextAppearance.ChartTextFont = New Font("Arial", 9)
        lineChartTemp.ChartText.Add(chartTextAppearance)
        lineChart.ChartText.Add(chartTextAppearance)

        Dim lineTemp As LineAppearance = New LineAppearance()
        lineTemp.IconAppearance.Icon = SymbolIcon.Circle
        lineTemp.IconAppearance.IconSize = SymbolIconSize.Small
        lineTemp.Thickness = 3
        lineChartTemp.LineAppearances.Add(lineTemp)
        lineChart.LineAppearances.Add(lineTemp)

        seriesTemp = New NumericTimeSeries()
        seriesTemp.Label = "Temp"
        seriesTemp.PEs.Add(New PaintElement(Color.FromArgb(198, 141, 78)))

        seriesLine = New NumericTimeSeries()
        seriesLine.Label = "Respiration"
        seriesLine.PEs.Add(New PaintElement(Color.FromArgb(96, 147, 186)))

        ' you need CandleSeries for Candle chart
        seriesCandle = New CandleSeries()
        seriesCandle.Label = "Respiration"
        seriesCandle.PEs.Add(New PaintElement(Color.FromArgb(96, 147, 186)))

        seriesTemp.Points.Add(New NumericTimeDataPoint(DateTime.Today, 40.0, DateTime.Today, False))
        seriesTemp.Points.Add(New NumericTimeDataPoint(DateTime.Today.AddDays(1), 38.2, DateTime.Today.AddDays(1), False))
        seriesTemp.Points.Add(New NumericTimeDataPoint(DateTime.Today.AddDays(2), 40.2, DateTime.Today.AddDays(2), False))
        seriesTemp.Points.Add(New NumericTimeDataPoint(DateTime.Today.AddDays(3), 40.2, DateTime.Today.AddDays(3), False))

        seriesLine.Points.Add(New NumericTimeDataPoint(DateTime.Today, 30.8, DateTime.Today, False))
        seriesLine.Points.Add(New NumericTimeDataPoint(DateTime.Today.AddDays(1), 44.05, DateTime.Today.AddDays(1), False))
        seriesLine.Points.Add(New NumericTimeDataPoint(DateTime.Today.AddDays(2), 15.07, DateTime.Today.AddDays(2), False))

        'seriesCandle.Points.Add(New NumericTimeDataPoint(DateTime.Today, 30.0, DateTime.Today, False))
        'seriesCandle.Points.Add(New NumericTimeDataPoint(DateTime.Today, 60.0, DateTime.Today, False))
        'seriesCandle.Points.Add(New NumericTimeDataPoint(DateTime.Today.AddDays(1), 180.0, DateTime.Today.AddDays(1), False))
        'seriesCandle.Points.Add(New NumericTimeDataPoint(DateTime.Today.AddDays(2), 182.0, DateTime.Today.AddDays(2), False))
        seriesCandle.Points.Add(New CandleDataPoint(DateTime.Today, 30, 60, 70, 20, 0, "Test", False))
        seriesCandle.Points.Add(New CandleDataPoint(DateTime.Today, 60, 80, 90, 50, 0, "Test", False))
        seriesCandle.Points.Add(New CandleDataPoint(DateTime.Today.AddDays(1), 150, 160, 180, 120, 0, "Test", False))
        seriesCandle.Points.Add(New CandleDataPoint(DateTime.Today.AddDays(1), 155, 165, 182, 140, 0, "Test", False))

        chtlayerTemp.Series.Add(seriesTemp)
        UltraChart1.CompositeChart.Series.Add(seriesTemp)
        chtlayerTemp.AxisX = axisX
        chtlayerTemp.AxisY = axYTemp
        UltraChart1.CompositeChart.ChartLayers.Add(chtlayerTemp)

        chtlayerY2Line.Series.Add(seriesLine)
        UltraChart1.CompositeChart.Series.Add(seriesLine)
        chtlayerY2Line.AxisX = axisX
        chtlayerY2Line.AxisY = axisY2
        UltraChart1.CompositeChart.ChartLayers.Add(chtlayerY2Line)

        chtlayerY2Candle.Series.Add(seriesCandle)
        UltraChart1.CompositeChart.Series.Add(seriesCandle)
        chtlayerY2Candle.AxisX = axisXCandle
        chtlayerY2Candle.AxisY = axisY2
        ' You need to set AxisX, AxisY and AxisY2 for Candle chart
        chtlayerY2Candle.AxisY2 = axisYCandle
        UltraChart1.CompositeChart.ChartLayers.Add(chtlayerY2Candle)
    End Sub

End Class
